Name:		uln-yum-mirror
Version:	0.1.5
Release:	1%{?dist}
Summary:	Setup a local yum mirror from the Unbreakable Linux Network

Group:		System Environment/Base
License:	GPL
Vendor:         Oracle USA
URL:		http://linux.oracle.com/
Source0:	%{name}-%{version}.tar.gz
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildArch:	noarch

Obsoletes:      uln-yum-proxy
Requires:       hardlinkpy
Requires:       httpd
Requires:       python-urlgrabber

%if 0%{?rhel} >= 5
Requires:       yum-arch
%if 0%{?rhel} >= 6
Requires:       createrepo >= 0.9.9-17.0.1
Requires:       yum-utils >= 1.1.30-6
%else
Requires:       createrepo
Requires:       yum-rhn-plugin
Requires:       yum-utils >= 1.1.16-21.0.1
%endif
%else
Requires:       createrepo
Requires:       yum
%endif

%description
Creates a local yum mirror from subscribed Unbreakable Linux Network channels. 

%prep
%setup -q


%build


%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}%{_sysconfdir}/cron.daily
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sysconfdir}/pki/rpm-gpg
mkdir -p %{buildroot}%{_localstatedir}/log

cp uln-yum-mirror %{buildroot}%{_bindir}
cp uln-yum-mirror.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/uln-yum-mirror
cp uln-yum-mirror.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/uln-yum-mirror
cp uln-yum-mirror.cron %{buildroot}%{_sysconfdir}/cron.daily/uln-yum-mirror
cp RPM-GPG-KEY-oracle-el4 %{buildroot}%{_sysconfdir}/pki/rpm-gpg
cp RPM-GPG-KEY-oracle-ol5 %{buildroot}%{_sysconfdir}/pki/rpm-gpg
cp RPM-GPG-KEY-oracle-ol6 %{buildroot}%{_sysconfdir}/pki/rpm-gpg

touch %{buildroot}%{_localstatedir}/log/uln-yum-mirror.log

%clean
rm -rf %{buildroot}

%post
# Install EL4 RPM-GPG-KEY if needed
rpm -q gpg-pubkey-b38a8516-44fd79eb >/dev/null 2>&1 || \
  rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-oracle-el4
# Install EL5 RPM-GPG-KEY if needed
rpm -q gpg-pubkey-1e5e0159-464d0428 >/dev/null 2>&1 || \
  rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol5
# Install OL6 RPM-GPG-KEY if needed
rpm -q gpg-pubkey-ec551f03-4c2d256a >/dev/null 2>&1 || \
  rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol6

%files
%defattr(644, root, root)
%doc COPYING
%doc README.html
%doc README
%config(noreplace) %{_sysconfdir}/sysconfig/uln-yum-mirror
%attr(755,root,root) %{_bindir}/uln-yum-mirror
%attr(755,root,root) %{_sysconfdir}/cron.daily/uln-yum-mirror
%{_sysconfdir}/logrotate.d/uln-yum-mirror
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-el4
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol5
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol6
%ghost %{_localstatedir}/log/uln-yum-mirror.log

%changelog
* Wed Jan 22 2014 Avi Miller <avi.miller@oracle.com> - 0.1.5-1
- Check physical memory and disable the "--update" parameter to createrepo if less than 6GB. This should avoid OOM-killer on large repos

* Fri Jan 10 2014 Avi Miller <avi.miller@oracle.com> - 0.1.4-2
- Set reposync to remove RPMs that fail GPG checking after downloading

* Fri Jan 10 2014 Avi Miller <avi.miller@oracle.com> - 0.1.4-1
- Set hardlinkpy to ensure filenames are identical
- Exclude cache and metadata directories from hardlinking to improve scanning performance
- Set yum-arch to quiet to reduce log output

* Mon Nov 25 2013 Avi Miller <avi.miller@oracle.com> - 0.1.3-4
- Fix incorrect path in logrotate script
- Set logrotate to compress uln-yum-mirror logs on a daily basis

* Tue Nov 19 2013 Avi Miller <avi.miller@oracle.com> - 0.1.3-3
- Switch license to GPL and add GPL license text
- Add README documentation

* Mon Nov 04 2013 Avi Miller <avi.miller@oracle.com> - 0.1.3-2
- Set minimum yum-utils version to ensure reposync --source support on Oracle Linux 5

* Fri Nov 01 2013 Avi Miller <avi.miller@oracle.com> - 0.1.3-1
- Remove check for uln-yum-proxy

* Thu Oct 10 2013 Avi Miller <avi.miller@oracle.com> - 0.1.1-1
- Obsolete uln-yum-proxy
- Add dependencies for syncing, creating and hosting yum repos from uln-yum-proxy
- Install RPM-GPG-KEY for EL4, OL5 and OL6
- Track logfile in RPM file list

* Tue Oct 08 2013 Avi Miller <avi.miller@oracle.com> - 0.0.11-1
- Add locking to cron script so that only one instance of uln-yum-mirror runs

* Wed Oct 02 2013 Avi Miller <avi.miller@oracle.com> - 0.0.10-1
- Added parameter to make hardlinkpy quieter when logging
- Remove support for running the script on OL4/EL4
- Check for rpm installation more effeciently
- Make reposync run quiet
- move hardlinking to after all the repos are downloaded

* Mon Sep 30 2013 Avi Miller <avi.miller@oracle.com> - 0.0.7-1
- Added hardlinkpy support to reduce storage requirements
- Added logging support and log rotation

* Thu Sep 19 2013 Avi Miller <avi.miller@oracle.com> - 0.0.4-1
- Added option to download all packages instead of just latest packages
- Added cronjob support

* Thu Nov 09 2006 Avi Miller <avi.miller@oracle.com> - 0.0.1-1
- Initial version
